/* This file is tc-arm.h
	Contributed by Richard Earnshaw (rwe@pegasus.esprit.ec.org)
        Modified by David Taylor (dtaylor@uk.co.armltd)

   Copyright (C) 1994 Free Software Foundation, Inc.

   This file is part of GAS, the GNU Assembler.

   GAS is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   GAS is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with GAS; see the file COPYING.  If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  */

#define TC_ARM 1

#define TARGET_ARCH bfd_arch_arm

#define AOUT_MACHTYPE 0

#define DIFF_EXPR_OK

#define LITTLE_ENDIAN 1234
#define BIG_ENDIAN 4321

/* If neither TARGET_BYTES_BIG_ENDIAN nor TARGET_BYTES_LITTLE_ENDIAN
   is specified, default to little endian.  */
#ifndef TARGET_BYTES_BIG_ENDIAN
#ifndef TARGET_BYTES_LITTLE_ENDIAN
#define TARGET_BYTES_LITTLE_ENDIAN
#endif
#endif

#ifdef TARGET_BYTES_BIG_ENDIAN
#define BYTE_ORDER	BIG_ENDIAN
#else
#define BYTE_ORDER	LITTLE_ENDIAN
#endif

#ifdef OBJ_AOUT
#ifdef TE_RISCIX
#define COFF_MAGIC ARMMAGIC
#define TARGET_FORMAT "a.out-riscix"
#else
#ifdef TE_NetBSD
#define TARGET_FORMAT "a.out-arm-netbsd"
#define TARGET_MACHINE M_ARM_NETBSD
#else
#define COFF_MAGIC ARMMAGIC
#ifdef TARGET_BYTES_BIG_ENDIAN
#define TARGET_FORMAT "a.out-arm-big"
#else
#define TARGET_FORMAT "a.out-arm-little"
#endif
#endif
#endif
#endif

#ifdef OBJ_AIF
  #define TARGET_FORMAT "aif"
#endif

#define md_convert_frag(b,s,f) {as_fatal ("arm convert_frag\n");}

#define md_after_pass_hook() arm_after_pass_hook()
#define md_start_line_hook() arm_start_line_hook()
#define tc_frob_label(S) arm_frob_label(S) 

#define obj_fix_adjustable(fixP) 0

#if 0	/* It isn't as simple as this */
#define tc_frob_symbol(sym,punt)	\
{	if (S_IS_LOCAL (sym))		\
	  {				\
	    punt = 1;			\
	    sym->sy_used_in_reloc = 0;	\
	  }}
#endif 

#if 0
#define tc_crawl_symbol_chain(a)	{;}	/* not used */
#define tc_headers_hook(a)		{;}	/* not used */
#endif

#define tc_aout_pre_write_hook(x)	{;}	/* not used */

#define LISTING_HEADER "ARM GAS "

#define OPTIONAL_REGISTER_PREFIX '%'

/* end of tc-arm.h */
